import java.util.*;

public class PersonClient {
   
   /**
   *Main method prints out various sorts
   *@param args commandline input
   */
   public static void main(String[] args) {
      Person[] people = generatePeople();
      
      // Print the original list.       
      System.out.println("Original list: " + Arrays.toString(people));
      
      Arrays.sort(people, new PersonLastNameComparator());
      System.out.println("Sorted by last name: " + Arrays.toString(people));

      Arrays.sort(people, new Person.FirstNameComparator());
      System.out.println("Sorted by first name: " + Arrays.toString(people));


      Arrays.sort(people, new Comparator<Person>() {
         @Override
         public int compare(Person p1, Person p2) {
         
            return p1.getAge() - p2.getAge();
         }
      });
      System.out.println("Sorted by age (ascending): " + Arrays.toString(people));
      
      Arrays.sort(people, 
         (Person p1, Person p2)->{return p2.getAge() - p1.getAge();});
      System.out.println("Sorted by age (descending): " + Arrays.toString(people));
      
      







   }
   
   /**
   *Generates a list of three people for testing purposes
   *@return a default list of people
   */
   private static Person[] generatePeople() {

      Person[] people = {
         new Person("Emma", "Watson", 30), 
         new Person("Ncuti", "Gatwa", 27), 
         new Person("Tina", "Fey", 49), 
         new Person("Idris", "Elba", 47),
         new Person("Awkwafina", "", 31),
         new Person("Michael", "Mando", 38),
         new Person("Judi", "Dench", 85),  
         new Person("Adam", "Driver", 36),
         new Person("Logan", "Browning", 30), 
         new Person("John", "Hamm", 49), 
         new Person("Dev", "Patel", 30), 
         new Person("Manny", "Jacinto", 32), 
         new Person("Jennifer", "Aniston", 51),  
         new Person("Morgan", "Freeman", 82),  
      };
      return people;
   }

}
